/*
 *	   RS232 Serial Control
 *          G-Tronic Robotic
 * programma di test della comunicazione seriale
 * include 14 servo e LED per test seriale su RA0
 *    @P123 ret  spegne LED di test
 *    @Q123 ret  riaccende LED di test
 *       attenzioen:P e Q maiscoli
 */

#include "pic.h"
#include "delay.h"

static bit Servo1	@ ((unsigned)&PORTB*8+0);	// R/W


extern void Var_Init(void);  //prototipi	
extern void Par_ser(void);

unsigned char S1H;  //variabili
unsigned char S1L;
unsigned char C1,C2,C3,C4,Valore,Flags;
int Pos1;

main(void)
{
TRISA = 0x00;     // tutte uscite per evitare interferenze
TRISB = 0x00;      // tutte uscite
TRISC = 0xf8;  // bit 6-7 Seriale
TRISD = 0x00;       // tutte uscite
PORTA = 0x01;  // azzera i pin del PORT A ma accende il primo LED port A
PORTB = 0x00;     // azzera i pin del PORT B
PORTC = 0x00;       // azzera i pin del PORT C
PORTD = 0x01;  // D0 si attiva alla prima scansione
ADCON1= 0x87;  // PORTA all digital mode

//Inizializzazione uart
TXSTA= 0x20;  // TX abilitato
RCSTA= 0X90;  // Registro RX USART
BRGH = 1;   // USART High velocity
SPBRG= 25;   // Baud Rate Generator (25=9600 baud)

//Inizializzazione TIMER1
T1CON   = 0;  // TIMER 1 resettato
T1CKPS1 = 0,T1CKPS0=0; // TIMER1 prescaler = 1
T1OSCEN = 0;  // TIMER1 external oscillator disable
TMR1CS  = 0;  // TIMER1 internal clock (fosc/4)
TMR1ON  = 0;  // TIMER1 in STOP

//Inizializzazione interrupt
INTCON = 0;  // Interrupt disabilitato
PIE1   = 0;  // Interrupt di periferica disabilitati
GIE    = 1;  // Global Interrupt Enable
PEIE   = 1;  // Periferal Interrupt Enable
RCIE   = 1;  // USART Receive Interrupt Enable
}

void interrupt SerChar(void)    //prototipo ricezione
{
  if (RCREG==0x40 | Valore > 6)  //se arriva la chiocciola dimensiona la stringa
   {
   C1=0,C2=0,C3=0,C4=0;  //azzero la stringa
   Valore=0,Flags=0;
   }
  if (Valore==1) C1=RCREG; //ricezione della stringa comandi
  if (Valore==2) C2=RCREG;
  if (Valore==3) C3=RCREG;
  if (Valore==4) C4=RCREG;
  if ((Valore==5 )&& (RCREG==0x0d)) Flags=1; // <CR> terminatore di stringa
  Valore++;
 if (Flags==1) Par_ser(); //lancia analisi della stringa ricevuta
}

void
Par_ser(void)		       // Analisi comandi
{
 Flags=0;
 switch (C1)
  {
   case 0x51: //carattere Q maiscolo accende LED test seriale
   PORTD = 0x02;
   break;
  }
	  /*
  case 0x51:    //carattere A
   //PORTD = 0x00;	//Pos1 assume il valore C2 trasmesso con A
   
	 switch (C2)
	  {
	  case 0x01:    //carattere A
	   PORTD = 0x00;	//Pos1 assume il valore C2 trasmesso con A
	   break; 
	   case 0x02: //carattere Q maiscolo accende LED test seriale
	   PORTD = 0x01; 
	   break; 
	   case 0x03: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x02; 
	   break; 
	   case 0x04: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x03; 
	   break; 
	   case 0x05: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x04; 
	   break; 
	   case 0x06: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x05; 
	   break; 
	   case 0x07: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x06; 
	   break; 
	   case 0x08: //carattere P maiscolo spegne LED test seriale
	   PORTD = 0x07; 
	   break; 
	  }
	   switch (C3)
	  {
	  case 0x01:    //carattere A
	   PORTB = 0x00;	//Pos1 assume il valore C2 trasmesso con A
	   break; 
	   case 0x02: //carattere Q maiscolo accende LED test seriale
	   PORTB = 0x01; 
	   break; 
	   case 0x03: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x02; 
	   break; 
	   case 0x04: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x03; 
	   break; 
	   case 0x05: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x04; 
	   break; 
	   case 0x06: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x05; 
	   break; 
	   case 0x07: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x06; 
	   break; 
	   case 0x08: //carattere P maiscolo spegne LED test seriale
	   PORTB = 0x07; 
	   break; 
	  }
	   switch (C4)
	  {
	  case 0x01:    //carattere A
	   PORTC = 0x00;	//Pos1 assume il valore C2 trasmesso con A
	   break; 
	   case 0x02: //carattere Q maiscolo accende LED test seriale
	   PORTC = 0x01; 
	   break; 
	   case 0x03: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x02; 
	   break; 
	   case 0x04: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x03; 
	   break; 
	   case 0x05: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x04; 
	   break; 
	   case 0x06: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x05; 
	   break; 
	   case 0x07: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x06; 
	   break; 
	   case 0x08: //carattere P maiscolo spegne LED test seriale
	   PORTC = 0x07; 
	   break; 
	  }
	  break;
	  }*/
}


